#!/bin/sh
WATCHDOG_SLEEP_SEC=10
MAC_ADDRESS_1="04:xx:xx:xx:xx:77" # MAC 
c1_last_state="0"
MAC_ADDRESS_2="78:xx:xx:xx:xx:0B" # MAC 
c2_last_state="0"
HOST_1="htpc-lan.XXXXX.local" #   
h1_last_state="x"
HOST_2="htpc-wlan.XXXXX.local"
h2_last_state="x"
HOST_3="alfa-usb-wlan.XXXXX.local"
h3_last_state="x"
HOST_4="alfa-spoofed.XXXXX.local"
h4_last_state="x"
HOST_5="mackentorsken.XXXXX.local"
h5_last_state="x"
HOST_10="www.z-wave.ru"
h10_last_state="x"
VERAURL="http://192.168.XXX.XX:3480/data_request?id=variableset&DeviceNum=57&serviceId=urn:dcineco-com:serviceId:MSwitch1&Variable="
x=0
y=0

while sleep $WATCHDOG_SLEEP_SEC
do
	if [ "$x" == 180 ]; then
		# Every 30 minutes or so we do them all again, just in case Vera missed something
		x=0
		c1_last_state="0"
		c2_last_state="0"
		h1_last_state="x"
		h2_last_state="x"
		h3_last_state="x"
		h4_last_state="x"	
		h10_last_state="x"	
	fi
	x=$(( $x + 1 ))

	c1_new_state=`wl -a wl0.1 assoclist | grep $MAC_ADDRESS_1`
	if [ "$c1_new_state" == "$c1_last_state" ] ; then
		sleep 0
	else
		c1_last_state="$c1_new_state"
		if [ "$c1_new_state" == "assoclist $MAC_ADDRESS_1" ]; then
			wget -qs "${VERAURL}Status1&Value=1"
		else
			wget -qs "${VERAURL}Status1&Value=0"
		fi
	fi

	c2_new_state=`wl -a wl0.1 assoclist | grep $MAC_ADDRESS_2`
	if [ "$c2_new_state" == "$c2_last_state" ] ; then
		sleep 0
	else
		c2_last_state="$c2_new_state"
		if [ "$c2_new_state" == "assoclist $MAC_ADDRESS_2" ]; then
			wget -qs "${VERAURL}Status2&Value=1"
		else
			wget -qs "${VERAURL}Status2&Value=0"
		fi
	fi

	# Ping LAN hosts
	h1_new_state=`ping -w 1 -c 1 $HOST_1 | grep 'received' | awk -F',' '{ print $2}' | awk '{ print $1}'`
	if [ "$h1_new_state" == "$h1_last_state" ] ; then
		sleep 0
	else
		h1_last_state="$h1_new_state"
		if [ "$h1_new_state" == 1 ]; then
			wget -qs "${VERAURL}Status4&Value=1"
		else
			wget -qs "${VERAURL}Status4&Value=0"
		fi
	fi

	h3_new_state=`ping -w 1 -c 1 $HOST_3 | grep 'received' | awk -F',' '{ print $2}' | awk '{ print $1}'`
	if [ "$h3_new_state" == "$h3_last_state" ] ; then
		sleep 0
	else
		h3_last_state="$h3_new_state"
		if [ "$h3_new_state" == "1" ]; then
			wget -qs "${VERAURL}Status6&Value=1"
		else
			wget -qs "${VERAURL}Status6&Value=0"
		fi
	fi

	h4_new_state=`ping -w 1 -c 1 $HOST_4 | grep 'received' | awk -F',' '{ print $2}' | awk '{ print $1}'`
	if [ "$h4_new_state" == "$h4_last_state" ] ; then
		sleep 0
	else
		h4_last_state="$h4_new_state"
		if [ "$h4_new_state" == "1" ]; then
			wget -qs "${VERAURL}Status5&Value=1"
		else
			wget -qs "${VERAURL}Status5&Value=0"
		fi
	fi

	h5_new_state=`ping -w 1 -c 1 $HOST_5 | grep 'received' | awk -F',' '{ print $2}' | awk '{ print $1}'`
	if [ "$h5_new_state" == "$h5_last_state" ] ; then
		sleep 0
	else
		h5_last_state="$h5_new_state"
		if [ "$h5_new_state" == "1" ]; then
			wget -qs "${VERAURL}Status3&Value=1"
		else
			wget -qs "${VERAURL}Status3&Value=0"
		fi
	fi

	if [ "$y" == 11 ]; then
		# We dont want to ping an external site so often, might be considered as abuse
		y=0
	fi
	y=$(( $y + 1 ))

	if [ "$y" == 1 ] ; then
		h10_new_state=`ping -w 5 -c 1 $HOST_10 | grep 'received' | awk -F',' '{ print $2}' | awk '{ print $1}'`
		if [ "$h10_new_state" == "$h10_last_state" ] ; then
			sleep 0
		else
			h10_last_state="$h10_new_state"
			if [ "$h10_new_state" == "1" ]; then
				wget -qs "${VERAURL}Status8&Value=1"
			else
				wget -qs "${VERAURL}Status8&Value=0"
			fi
		fi
	fi

done

#    farang, silencery  Damian R http://forum.micasaverde.com
# z-wave.ru,  